/*
 * GStreamer Intel MSDK plugin
 * Copyright (c) 2022 Intel Corporation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __GST_MSDKAV1ENC_H__
#define __GST_MSDKAV1ENC_H__

#include <gst/codecparsers/gstav1parser.h>
#include "gstmsdkenc.h"

G_BEGIN_DECLS

#define GST_TYPE_MSDKAV1ENC \
  (gst_msdkav1enc_get_type())
#define GST_MSDKAV1ENC(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),GST_TYPE_MSDKAV1ENC,GstMsdkAV1Enc))
#define GST_MSDKAV1ENC_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),GST_TYPE_MSDKAV1ENC,GstMsdkAV1EncClass))
#define GST_IS_MSDKAV1ENC(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),GST_TYPE_MSDKAV1ENC))
#define GST_IS_MSDKAV1ENC_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),GST_TYPE_MSDKAV1ENC))

typedef struct _GstMsdkAV1Enc GstMsdkAV1Enc;
typedef struct _GstMsdkAV1EncClass GstMsdkAV1EncClass;

struct _GstMsdkAV1Enc
{
  GstMsdkEnc base;

  gint profile;
  gushort num_tile_rows;
  gushort num_tile_cols;
  guint b_pyramid;
  guint p_pyramid;

  mfxExtAV1BitstreamParam ext_av1_bs_param;
  mfxExtAV1ResolutionParam ext_av1_res_param;
  mfxExtAV1TileParam ext_av1_tile_param;
};

struct _GstMsdkAV1EncClass
{
  GstMsdkEncClass parent_class;
};

GType gst_msdkav1enc_get_type (void);

G_END_DECLS

#endif /* __GST_MSDKAV1ENC_H__ */